'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.unmountPortal = exports.getPortalContainer = exports.detectIsPortal = exports.createPortal = void 0;
const core_1 = require('@dark-engine/core');
const $$portal = Symbol('portal');
function createPortal(slot, container) {
  if (!(container instanceof Element)) {
    throw new Error(`[Dark]: createPortal receives only Element as container!`);
  }
  return Portal({ [$$portal]: container, slot });
}
exports.createPortal = createPortal;
const Portal = (0, core_1.createComponent)(
  ({ slot, ...rest }) => {
    (0, core_1.useMemo)(() => (rest[$$portal].innerHTML = ''), []);
    return slot;
  },
  { token: $$portal },
);
const detectIsPortal = instance => (0, core_1.detectIsComponent)(instance) && instance.token === $$portal;
exports.detectIsPortal = detectIsPortal;
const getPortalContainer = instance => (detectIsPortal(instance) ? instance.props[$$portal] : null);
exports.getPortalContainer = getPortalContainer;
function unmountPortal(fiber) {
  const container = getPortalContainer(fiber.instance);
  if (container) {
    container.innerHTML = '';
  }
}
exports.unmountPortal = unmountPortal;
//# sourceMappingURL=portal.js.map
